



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JAVA在IO流量汇总</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JAVA在IO流量汇总</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:22:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>本文是在学习中的总结，欢迎转载但请注明出处：<a href="http://blog.csdn.net/pistolove/article/details/42119261" rel="external nofollow noreferrer">http://blog.csdn.net/pistolove/article/details/42119261</a></p>
<div><br>
</div>
<p>我想你对JAVA的IO流有所了解，平时使用的也比較的多，可是对于其详细分类和继承体系可能知道的并不多，可能也非常少去看相关的API文档，找出当中的关系和各自的应用情形。本文简单对经常使用的IO流进行分类整理，并简单举例说明其应用。希望本文对你有所帮助。</p>
<p><strong>（A）IO流大致分为两种：</strong></p>
<p>（1）字节流：相应抽象类为InputStream（输入流）和 OutputStream（输出流）。&nbsp;<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; （2）字符流：相应抽象类为Reader（输入流）和Writer（输出流）。</p>
<p><p><strong>（B）详细实现例如以下</strong>：</p>
<p>（1）字节流：（经常使用的）FileInputStream实现了InputStream。<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;&nbsp; &nbsp; &nbsp; &nbsp;（经常使用的）FileOutputStream实现了OutputStream。&nbsp;<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp;&nbsp;（2）字符流：（经常使用的）BufferedReader、InputStreamReader、 StringReader实现了Reader。FileReader继承了InputStreamReader。<br /><br />
&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;（经常使用的）BufferedWriter、OutputStreamWriter、StringWriter实现了Writer，FileWriter继承了OutputStreamWriter。</p>
<p><p><strong>（C）实现类详情及使用情况例如以下：</strong></p>
<p><strong><br /><br />
</strong></p>
<p>输出流：</p>
<p>（1）OutputStreamWriter是字符流通向字节流的桥梁：使用指定的 charset 将要向其写入的字符编码为字节。它使用的字符集能够由名称指定或显式给定，否则可能接受平台默认的字符集。</p>
<p>每次调用 write() 方法都会针对给定的字符（或字符集）调用编码转换器。在写入基础输出流之前。得到的这些字节会在缓冲区累积。能够指定此缓冲区的大小。只是，默认的缓冲区对多数用途来说已足够大。</p>
<p>为了达到最高效率，可考虑将 OutputStreamWriter<br />
 包装到 BufferedWriter 中以避免频繁调用转换器。</p>
<p>比如：&nbsp;<br /><br />
BufferedWriter out = new BufferedWriter(new OutputStreamWriter(System.out));</p>
<p>（2）FileReader 用来读取字符文件的便捷类，用于读取字符流。</p>
<p>（3）BufferedReader具有缓冲区，从字符输入流中读取文本。缓冲各个字符。从而实现字符、数组和行的高效读取。</p>
<p>（4）StringReader &nbsp;一个字符串的字符输入流。</p>
<p>（5）FileInputStream 要读取原始字节流。经常使用于读二进制文件，如图片、声音、影像等文件。</p>
<p>输入流：</p>
<p>（1）InputStreamReader是字节流通向字符流的桥梁：它使用指定的 charset 读取字节并将其解码为字符。每次调用其一个 read() 方法都会导致从基础输入流读取一个或多个字节。要启用从字节到字符的有效转换。能够提前从基础流读取很多其它的字节，使其超过满足当前读取操作所需的字节。为了达到最高效率，可要考虑在 BufferedReader 内包装 InputStreamReader。比如：&nbsp;BufferedReader<br />
 in = new BufferedReader(new InputStreamReader(System.in));</p>
<p>（2）FileWriter 用来写入字符文件的便捷类。</p>
<p>（3）BufferedWriter &nbsp;具有缓冲区，将文本写入字符输出流。缓冲各个字符。从而提供单个字符、数组和字符串的高效写入。</p>
<p>（4）StringWriter &nbsp;一个字符串的字符输出流。能够用其回收在字符串缓冲区中的输出来构造字符串。</p>
<p>（5）FileOutputStream 写入原始字节流。</p>
<p>经常使用于读二进制文件，如图片、声音、影像等文件。</p>
<p><strong>（D）代码实例分析例如以下：</strong></p>
<pre class="prettyprint linenums">import java.io.BufferedReader;<br />
import java.io.BufferedWriter;<br />
import java.io.File;<br />
import java.io.FileInputStream;<br />
import java.io.FileOutputStream;<br />
import java.io.FileReader;<br />
import java.io.FileWriter;<br />
import java.io.IOException;<br />
import java.io.InputStream;<br />
import org.junit.Test;

public class TestStream  {<br />
	// 读取文件里字符<br />
	@Test<br />
	public void testRead() throws IOException {<br />
		String path = &quot;read.txt&quot;;<br />
		FileReader read = new FileReader(path);<br />
		BufferedReader reader = new BufferedReader(read);<br />
		while (reader.readLine() != null) {<br />
			String s = reader.readLine();<br />
			System.err.println(s);<br />
		}<br />
		reader.close();<br />
	}

	// 写入字符到文件<br />
	@Test<br />
	public void testWrite() throws IOException {<br />
		String path = &quot;write.txt&quot;;<br />
		FileWriter write = new FileWriter(path);<br />
		BufferedWriter writer = new BufferedWriter(write);<br />
		char[] buffer = new char[1024];<br />
		for (int i = 0; i &lt; 1024; i++) {<br />
			if ((char) &#039;a&#039; + i &gt; Character.MAX_VALUE) {<br />
				buffer[i] = &#039;z&#039;;<br />
				System.err.println(1);<br />
			} else {<br />
				buffer[i] = (char) (&#039;a&#039; + i);<br />
			}

		}<br />
		writer.write(buffer);<br />
		writer.close();<br />
	}

	// 删除文件内容<br />
	@Test<br />
	public void testDelete() throws IOException {<br />
		String path = &quot;write.txt&quot;;<br />
		FileWriter write = new FileWriter(path);<br />
		BufferedWriter writer = new BufferedWriter(write);<br />
		StringBuffer buffer = new StringBuffer();<br />
		writer.write(buffer.toString());<br />
		writer.close();<br />
	}

	// 替换内容<br />
	@Test<br />
	public void testDeleteAndReplace() throws IOException {<br />
		String path = &quot;write.txt&quot;;<br />
		FileWriter write = new FileWriter(path);<br />
		BufferedWriter writer = new BufferedWriter(write);<br />
		int i = 0;<br />
		while (++i &lt; 100) {<br />
			StringBuffer buffer = new StringBuffer();<br />
			buffer.append(Math.random());<br />
			writer.write(buffer.toString() + &quot;\r\n&quot;);<br />
		}<br />
		writer.close();<br />
	}

	// 拷贝一个文件内容到还有一个文件<br />
	@Test<br />
	public void copyFile(String oldPath, String newPath) {<br />
	       try {<br />
	           int byteread = 0;<br />
	           File oldfile = new File(oldPath);<br />
	           if (oldfile.exists()) {                  //文件存在时<br />
	               InputStream inStream = new FileInputStream(oldPath);      //读入原文件<br />
	               FileOutputStream fs = new FileOutputStream(newPath);<br />
	               byte[] buffer = new byte[100];<br />
				while ((byteread = inStream.read(buffer)) != -1) {<br />
	                   fs.write(buffer, 0, byteread);<br />
	               }<br />
	               inStream.close();<br />
	               fs.close();<br />
	           }<br />
	       }  catch (Exception e) {<br />
	           e.printStackTrace();<br />
	       }<br />
	   } 

	//读取字符流<br />
	@Test<br />
	public static void testReadByte() {<br />
		String path = &quot;write.txt&quot;;<br />
		File file = new File(path);<br />
		InputStream in = null;<br />
		try {<br />
			// 一次读一个字节<br />
			in = new FileInputStream(file);<br />
			int tempbyte;<br />
			while ((tempbyte = in.read()) != -1) {<br />
				System.out.write(tempbyte);<br />
			}<br />
			in.close();<br />
		} catch (IOException e) {<br />
			e.printStackTrace();<br />
			return;<br />
		}<br />
		try {<br />
			// 一次读多个字节<br />
			byte[] tempbytes = new byte[100];<br />
			int byteread = 0;<br />
			in = new FileInputStream(path);<br />
			while ((byteread = in.read(tempbytes)) != -1) {<br />
				System.out.write(tempbytes, 0, byteread);<br />
			}<br />
		} catch (Exception e1) {<br />
			e1.printStackTrace();<br />
		} finally {<br />
			if (in != null) {<br />
				try {<br />
					in.close();<br />
				} catch (IOException e1) {<br />
				}<br />
			}<br />
		}<br />
	}<br />
}
</pre>

<div>
<p>版权声明：本文博客原创文章，博客，未经同意，不得转载。</p></p></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv1vjjq.html">C&plus;&plus;11中自定义range</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvodky8.html">升级xcode7&period;0 第三方库不能用的解决方法（bitcode是什么鬼？）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jr5ygq.html">ghost xp 安装IIS，并配置WCF</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zdj5d9.html">ant  exec</a>
		</li>
						<li><a href="https://www.batexi.com/a/49561re8.html">poj 3468 成段增减</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxndrzz8.html">RunJS - 在线编辑、展示、分享、交流你的 JavaScript 代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxno46j8.html">Delphi  Refactor 重构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wv57xq.html">VC 为静态控件添加事件（修改ID号以后添加事件）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wn2owq.html">SQL Join&lpar;连接查询&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1n75v9.html">python-查询员工信息表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03zn4q.html">zoj 3647 Gao the Grid</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zepez9.html">WebStorm11 注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1ylxyq.html">Java进阶篇设计模式之一 ----- 单例模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1jyppq.html">CSS 背景图像 background属性简写</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj30ge9.html">了解AutoCAD对象层次结构 &mdash;&mdash; 3 &mdash;&mdash;数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvylo28.html">git关联远程仓库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy3lg19.html">sap 软件架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2zz0pq.html">PHP文件系统操作常用函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjg0dj9.html">python SMTP attachment</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd3woz9.html">【C&num;】委托中的匿名函数与lambda</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rgdv7d8.html">Java调用IIS发布的WebService</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mvzp38.html">获得树形json串</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kz0259.html">Keepalived&plus;LVS&plus;Nginx负载均衡之高可用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8men336q.html">WPF界面设计技巧（4）&mdash;自定义列表项样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpennvq.html">WPF界面设计技巧（3）&mdash;实现不规则动画按钮</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj134g8.html">初识Mongodb之&lbrack;CURD&rsqb;-PHP版</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj13ek8.html">使用Visual Studio 创建可视Web Part部件</a>
			</li>
						<li><a href="https://www.batexi.com/a/96po1e48.html">Mac OS X在建筑Python科学计算环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1ded2q.html">mysql 开放的telnet</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zmpmg9.html">道破Redis的VM</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
